# Вступление

Когда мы рассматривали предисловие к каждому изданию этой книги - у нас всегда было больше людей, от которых мы хотели бы получить вклад, чем страниц, которые мы могли бы выделить. В этом пятом издании мы снова попросили избранную группу людей из сообщества Asterisk написать несколько слов об Asterisk с их точки зрения.

## Джошуа Кольп (Старший разработчик программного обеспечения, Sangoma/Digium)

Более 15 лет назад я загрузил Asterisk на свой ноутбук и сделал свой первый VoIP-звонок с помощью IAX2 на АТС Digium. Я затаил дыхание в предвкушении, ожидая услышать голос, пока, наконец, звук Эллисон не раздался из моего ноутбука. В этот момент я понял, что в Asterisk есть что-то особенное. Это зажгло во мне искру интереса и воображения: мой ноутбук действительно сделал звонок! Осознание того, что всего лишь с небольшим усилием я могу принимать звонки и делать с ними то, что захочу, вызывало привыкание и возбуждение — чувство, разделяемое многими и по сей день.

Сегодня Asterisk сильно отличается от того, что было в то время. В прошлом она была в первую очередь ориентирован на то, чтобы быть АТС. Она обладала всеми этими особенностями и продолжала приобретать новые, чтобы продвинуться дальше в эту область. Однако со временем проект эволюционировал до такой степени, что Asterisk - это инструментарий, который можно использовать отдельно или в сочетании с другими проектами для создания вещей. Она существует для того, чтобы вызвать вопрос "Могу ли я это сделать?" - в твоем сознании и позволить тебе увидеть все до конца.

Этот простой вопрос - то, что движет многими решениями, принятыми в отношении Asterisk и ее направления. “Правильно ли это для пользователей?", "Неужели это то, что действительно нужно людям?", “Разве это ломает вещи?" "и “Могут ли они построить то, что они хотят с этим?" Вместе эти вопросы помогают гарантировать, что люди смогут реализовать свои идеи. Что меня сегодня волнует в Asterisk — видеть, как люди используют инструменты для создания чего-то нового без помех.

Я думаю, что в дальнейшем это будет продолжаться и для Asterisk. Она будет продолжать добавлять новые инструменты и функциональные возможности, для обеспечения большей гибкости и возможности для этих строительных вещей, уважая при этом свое наследие и то, как пользователи уже используют его. Она будет продолжать оставаться частью более крупных и лучших решений, некоторые из которых, возможно, даже не придут в голову сейчас. Мы сделали всего несколько шагов вперед и нам еще многое предстоит сделать.

Я призываю новых и старых пользователей Asterisk пересмотреть то, что может сделать Asterisk, изучить новые функции, которые были добавлены, и создать что-то новое и захватывающее из вашего обычного набора навыков. Если вы попали в тупик, где Asterisk не может сделать то, что вам нужно - тогда участвуйте в проекте и вносите свой вклад. Помогите другим, кто, возможно, пытается сделать то же самое. Станьте не просто тем, кто использует Asterisk, но и тем, кто помогает другим реализовать свою мечту.

## Дэн Дженкинс (Основатель компании Nimble Ape Ltd)

Asterisk был моей первой вылазкой в мир open source телефонии, и как веб-разработчик я обнаружил, что она сильно отличается от того, к чему я привык, исходя из веб-индустрии. С тех пор проект Asterisk продвинулся вперед, и теперь он включает в себя множество API и технологий, которые типичный веб-разработчик привык ожидать. Включение WebRTC и Asterisk Rest Interface имеет жизненно важное значение для интеграции с разработчиками, используемыми для построения веб-платформы. Asterisk — это то, вокруг чего я в конечном итоге построил свой бизнес - это действительно замечательная часть программного обеспечения, и у нее есть блестящее сообщество людей, которые её используют и улучшают. Мне было очень приятно быть частью этого сообщества и корректировать эту книгу для будущего сообщества.

## Джойс Уилмот (Старший веб-разработчик)

Я познакомился с Asterisk в 2012 году, когда работал в Voicenation - компании, предоставляющей прямой автоответчик 24/7/365 для тысяч клиентов. В то время колл-центр быстро перерастал стороннее программное обеспечение, которое они использовали. Не найдя гибкого и экономичного решения для своего быстрорасширяющегося колл-центра, Voicenation решила что им необходимо создать собственное программное обеспечение для колл-центра. Мне была поставлена задача создания такого программного обеспечения, с которой началось мое путешествие с Asterisk. То, что начиналось как монументальная задача (поскольку у меня не было предыдущего опыта IP-телефонии), быстро стало очарованием Asterisk, когда я обнаружил, как она упростила нашу установку, не жертвуя мощностью и гибкостью.

Перенесемся на девять лет вперед и десятки миллионов звонков спустя, а Asterisk по-прежнему верно и надежно управляет нашим колл-центром. Это было мое первое знакомство с программным обеспечением с открытым исходным кодом. Очевидно, что Asterisk - это история успеха open source, которая иллюстрирует, как программное обеспечение с открытым исходным кодом подпитывает предпринимательство — и как предпринимательство, в свою очередь, подпитывает развитие и совершенствование программного обеспечения с открытым исходным кодом. Я очень рад быть частью этого цикла и с нетерпением жду возможности стать частью сообщества, поскольку Asterisk постоянно развивается, чтобы идти в ногу с постоянно меняющимся миром телекоммуникаций.

## Мэтт Florell (Основатель VICIdial)

Мое первое знакомство с open source телефонией еще в 2001 году было на самом деле не с Asterisk. Оно состоялось с другим программным пакетом и заняло у меня пару месяцев, чтобы начать работать, используя простой IVR для регистрации запросов на контакт с моим работодателем, в то время. Это была не простая система для работы или модификация, поэтому я не делал с ней ничего другого, кроме того первого проекта IVR. Два года спустя я получил от одного клиента просьбу построить гораздо более сложную телефонную систему, которая требовала бы взаимодействия пользователей через компьютер. Я знал, что платформа, которую я использовал, не будет работать для такого проекта, поэтому я посмотрел на коммерческие и открытые варианты. Именно тогда я узнал об Asterisk, которая выглядела как идеальная платформа для этого проекта. Я купил карту T1, с помощью которой можно было провести некоторые тесты и в течение двух часов после ее прибытия я настроил ее и смог воспроизвести старый проект, на создание которого у меня ушло два месяца. После этого я попался на крючок. Проект VICIdial Open-Source Contact Center вырос из этого проекта; на сегодняшний день более 100 000 систем Asterisk были установлены в составе кластеров VICIdial, и это только те, о которых мы знаем.

Asterisk сильно отличался от большинства веб-пакетов с открытым исходным кодом, с которыми я работал в прошлом, и у него было довольно много причуд и ошибок в более ранние дни, которые нам приходилось обходить (иногда довольно творчески). Но более поздний опыт работы с веткой Asterisk 13 показал значительные улучшения как в производительности, так и в стабильности по сравнению с более ранними ветками. Кроме того, было добавлено много новых функций, позволивших нам добавить новые функциональные возможности в наш пакет VICIdial. Две из них - это возможность приостанавливать записи вызовов и добавление нескольких уровней регистрации нового носителя SIP.

Еще в 2003 году, когда я начал использовать Asterisk, настоящих “релизов" не было. Вы должны были найти стабильную сборку из одной из последних версий CVS и протестировать ее. С течением времени развитие и обслуживание различных отраслей стало намного более стабильным, а использование Asterisk в производственных системах по всему миру резко возросло. Сегодня Asterisk - это телефонное ядро тысяч различных предложений услуг, через которое ежедневно проходят миллиарды телефонных звонков. Оно устанавливается на самые разнообразные аппаратные средства, от крошечных встроенных систем до серверных ферм с сотнями мощных машин. В настоящее время миллионы людей, ежедневно использующих Asterisk, понятия не имеют, что они взаимодействуют с частью программного обеспечения с открытым исходным кодом.

Только среди нашей клиентской базы есть несколько компаний из списка Fortune 500, а также школьные округа, общественные клубы, политические организации, муниципальные службы экстренной помощи и, конечно же, тысячи различных видов коммерческих организаций. В то время как низкая стоимость приобретения является распространенной причиной для использования решения на основе Asterisk, мы часто слышим, что тот факт, что это открытый исходный код - является большим плюсом, а также отсутствие возможности блокировки источника. Один из наших крупных клиентов даже назвал использование программного обеспечения для телефонии с открытым исходным кодом “явным стратегическим преимуществом” по сравнению с конкурентами из-за гибкости систем и их способности самостоятельно управлять ими без необходимости полагаться на внешних источников. Судя по тому, что я видел до сих пор, будущее Asterisk - это постоянно растущая установленная база и постоянные усовершенствования. Я с нетерпением жду возможности поработать с ним еще как минимум 16 лет.

## Мэтт Фредриксон (Директор Asterisk Engineering, Sangoma/Digium)

У меня была возможность работать с Asterisk в течение последних 18 лет и я видел, как он вырос из небольшого проекта с одним или двумя людьми в нечто, что имеет свою собственную жизнь с сотнями участников. Удивительно видеть, сколько разных мест он нарушил традиционные телекоммуникации - дома, в офисе и на предприятии. По мере того как традиционные модели коммуникации меняются, проект Asterisk продолжает оставаться там, где он делает это лучше всего — наводя мосты между старыми формами коммуникации и новыми и раздвигая границы того, что можно сделать с новыми. Эта книга поможет вам увидеть самое современное лицо Asterisk и узнать как лучше использовать его в своей телекоммуникационной инфраструктуре. Огромное спасибо Джиму Ван Меггелену за всю тяжелую работу по составлению этого самого последнего издания.

[Аннотация](README.md) | [Содержание](SUMMARY.md) | [Предисловие](preface.md)
