# Глава 23. Asterisk: Будущее телефонии

> _Эй, я только что познакомился с тобой,_
>
> _И это безумие!_
>
> _Но вот мой номер телефона,_
>
> _Так что позвони мне, может быть?_
>
> --Carly Rae Jepsen

Мы подошли к последней главе этой книги. Мы рассмотрели много (и эта книга была значительно доработана за эти годы), но надеемся что мы ясно дали понять, что лишь просто поцарапали поверхность Asterisk. Чтобы завершить работу, мы хотим потратить некоторое время на изучение того, что могли бы увидеть от Asterisk и open source телефонии в ближайшем будущем.

Когда ещё писали первое издание _Asterisk: Будущее телефонии_ мы уверенно утверждали, что коммуникационные механизмы с открытым кодом, такие как Asterisk, вызовут сдвиг в мышлении, который трансформирует телекоммуникационную отрасль. Во многих отношениях наша вера была оказалась правильной; однако некоторые могут утверждать, что это была пустая победа, потому что то, что также произошло за это время - это сдвиг от телекоммуникаций как основного средства связи в реальном времени. Более молодые поколения почти не пользуются телефонными звонками и считают их разрушительными, раздражающими, а в некоторых случаях даже грубыми.

Таким образом, несмотря на то, что Asterisk открыл новый век для телекоммуникационной индустрии, теперь он стал эталоном для технологий, которые, по мнению многих, так же хороши, как и мертвы.

Хотя не может быть никаких сомнений в том, что телефон больше не является основной коммуникационной технологией в мире (далеко не случайно!), когда мы перегоняем коммуникации до их сути, мы обнаруживаем, что у этого материала еще может быть будущее.

## Телефон мертв (за исключением тех случаев, когда это не так)

Хотя очевидно, что молодые поколения уже не так часто пользуются телефоном, верно также и то, что старшие поколения очень недовольны и разочарованы современными коммуникационными технологиями. Для них телефон представляет собой надежный, предсказуемый и простой в понимании способ связи, и они, вероятно, будут продолжать использовать его до конца своей жизни. Поскольку в этом мире ужасно много пожилых людей, и многие из них являются высшими руководителями, лицами, принимающими решения, и акционерами — не говоря уже о состоятельных клиентах, похоже, что сегодня хорошей стратегией для бизнеса является продолжение обеспечения того, с помощью чего их клиенты могли связаться с ними по телефону.

Когда человек попробует все другие способы коммуникации, такие как электронная почта, веб-формы и, возможно, даже текстовые сообщения, он, наконец, возьмет телефон и позвонит. Похоже, что во многих случаях проблема, которая не могла быть решена никаким другим способом, наконец-то решится по телефону.

Было бы также правильно сказать, что все более бедные рабочие компании, занимающиеся обработкой коммуникаций со своими клиентами, являются источником большого разочарования и путаницы. Однако, как всегда, там, где есть проблема, есть и возможность. Компании, которые сохраняют приверженность к превосходной телекоммуникационной инфраструктуре, могут оказаться с явным конкурентным преимуществом, не используя ничего более сложного, чем хорошее старомодное обслуживание клиентов. Если вы хотите обслуживать клиентов старше 50 лет, вы должны сделать все возможное, чтобы ваша телефонная система работала хорошо.

Еще один интересный компонент традиционных телекоммуникационных сетей заключается в том, что, хотя мы никогда не можем быть уверены в том, что используем одно и то же программное обеспечение для конференц-связи (никогда в истории не было так много почти идентичных приложений, которые должны были быть установлены только для того, чтобы люди могли говорить друг с другом), мы можем быть разумно уверены, что если один из нас возьмет телефон и наберет номер телефона другого, успешный разговор будет возможен без каких-либо неисправностей или установки программного обеспечения. В эпоху, когда кажется, что никакая конференция не может начаться без того, чтобы кому-то не пришлось устранять неполадки в своем приложении, этот вид универсальной согласованности и надежности, вероятно, все еще имеет некоторое значение. Сегодняшнее горячее новое программное обеспечение для совместной работы в офисе - это завтрашняя забытая игрушка (куда ты, Skype?). Храбрые старые телефонные солдаты включились.

Мы пока не уверены, что телефон мертв.

## Перегрузка связи

Во многих отношениях способность к общению определяет наш вид. Да, другие существа способны сигнализировать друг другу базовыми способами, но наше увлечение созданием постоянно меняющихся и инновационных способов коммуникаций друг с другом - это не то, с чем бы сталкивалось любое другое существо.

От почтового голубя до телеграфа, телефона и телевидения, каждая новая технология служила одной и той же цели: улучшению нашей способности общаться. Сегодня мы достигли самой замечательной вещи: теперь разумно ожидать мгновенного общения практически с любым человеком на планете.

Проблема, которую мы никогда не предсказывали, заключается в том, что слишком много хорошего начало подавлять нас. Будет интересно посмотреть, как это происходит в культурном плане.

## Проблемы с разработкой открытого исходного кода

Хотя Александр Грэм Белл больше всего известен как отец телефона<sup><a href="#sn1">1</a></sup>, реальность такова, что во второй половине 1800-х годов десятки умов работали над достижением цели передачи голоса по телеграфным линиям. Эти люди были в основном деловыми людьми, стремящимися создать продукт, с помощью которого они могли бы сделать свои состояния.

Мы привыкли думать о традиционных телефонных компаниях как о монополиях, но это было не так в их первые дни. Ранняя история телефонных услуг проходила в очень конкурентной среде, с появлением новых компаний по всему миру, часто почти без уважения к патентам, которые они могли бы нарушить. Многие известные монополии получили свое начало через ведение (и победу) патентных войн.

Интересно сравнить историю телефона с историей GNU Linux и Интернета. В то время как телефон был создан как коммерческое мероприятие, а телекоммуникационная индустрия была создана с помощью судебных процессов и корпоративных поглощений, Linux и Интернет возникли из академического сообщества, которое имело тенденцию ценить обмен знаниями над прибылью.

К сожалению, в очередной раз слишком много хорошего стало захлестывать. То, что мы видели в последнее время - это потеря видения для разработки с открытым исходным кодом. Слишком мало разработчиков устали от требований слишком большого количества пользователей, не желающих вносить свой вклад. Большинство проектов с открытым исходным кодом должны были по необходимости оградить команду разработчиков от эгоистичных требований тех, кто намерен только брать и никогда не давать. Это злоупотребление разработчиками, к сожалению, даже распространилось на компании, которые построили высокодоходные бизнесы на проектах с открытым исходным кодом, в которые они никогда не вносили ни копейки. Многомиллиардный бизнес, получающий прибыль от усилий команды, едва способной оплачивать свои счета, не является моделью устойчивого развития. Остается посмотреть, как эта история будет развиваться, но программное обеспечение с открытым исходным кодом уже не то, что было 10 лет назад.

Asterisk повезло в том, что он финансируется усилиями Sangoma/Digium - родителей проекта. Их задачей было и всегда будет выяснить, как воспитать продукт таким образом, чтобы требования бизнеса были совместимы с потребностями проекта. Это была непростая задача. Мы будем болеть за них. До этих пор они проделали замечательную работу.

## Будущее Asterisk

Итак, есть ли у Asterisk будущее? Мы не видим, почему его не должно быть. Он продолжает делать то, что он всегда делал и также упорно работает, чтобы быть совместимым с подходящими технологиями, выходящими на поверхность. По крайней мере, Asterisk будет продолжать очень хорошо интегрироваться с телефонными технологиями и мы пока не готовы назвать эту историю полностью рассказанной.

### WebRTC

Следите за WebRTC. Мы подозреваем, что если у open source и open-standards коммуникаций есть какое-то будущее, WebRTC выступает в качестве наиболее перспективного кандидата для достижения этого.

Asterisk вряд ли будет в центре этой революции, но он будет играть определенную роль.

### Будущее телефонии

Телефония может выглядеть мертвой, но мы все еще видим движение в хвосте, и это действительно длинный хвост.

---

<a name="sn1">1</a> Вы когда-нибудь слышали об Элише Грее или Антонио Меуччи?

[Глава 22. Безопасность](glava-22.md) | [Содержание](SUMMARY.md) | [Об авторах](about-the-authors.md)
