# Предисловие

Это книга для всех, кто использует Asterisk.

Asterisk - это платформа конвергентной телефонии с открытым исходным кодом, которая предназначена в первую очередь для работы на Linux. Asterisk объединяет более чем 100-летние знания в области телефонии в надежный набор тесно интегрированных телекоммуникационных приложений. Сила Asterisk заключается в его настраиваемой природе, дополненной непревзойденным соответствием стандартам. Ни одна другая управленческая автоматизированная телефонная станция \(УАТС\) не может быть развернута таким множеством творческих способов.

Такие приложения, как голосовая почта, конференции, очереди вызовов и агенты, музыка на удержании и парковка вызовов - все это стандартные функции, встроенные прямо в программное обеспечение. Кроме того, Asterisk может интегрироваться с другими бизнес-технологиями таким образом, о котором закрытые, проприетарные УАТС вряд ли могут мечтать.

Asterisk может показаться довольно пугающим и сложным для нового пользователя, поэтому документация так важна для его роста. Документация снижает барьер для входа и помогает людям созерцать возможности.

Выпущенный при щедрой поддержке O'Reilly Media, [Asterisk: Окончательное руководство](http://shop.oreilly.com/product/0636920025894.do) - это пятое издание того, что ранее называлось [Asterisk: Будущее телефонии](http://shop.oreilly.com/product/9780596510480.do).

Эта книга была написана для участников сообщества Asterisk.

## Аудитория

Эта книга предназначена для того, чтобы быть нежной к тем, кто новичок в Asterisk, но мы предполагаем, что вы знакомы с базовым администрированием Linux, сетью и другими ИТ-дисциплинами. Если нет, мы рекомендуем вам изучить обширную и замечательную библиотеку книг, которые O'Reilly публикует по этим темам. Мы также предполагаем, что вы пока новичок в телекоммуникациях \(как традиционная коммутируемая Телефония, так и новый мир Voice over IP\).

Однако эта книга будет полезна и более опытному администратору Asterisk. Мы сами используем книгу в качестве ссылки на функции, которые мы не использовали в течение некоторого времени.

## Программное обеспечение

Эта книга сосредоточена на документировании версии 16 Asterisk; однако многие соглашения и большая часть информации в этой книге являются агностическими версиями. Linux - это операционная система, в которой мы запускали и тестировали Asterisk, и мы задокументировали инструкции по установке для CentOS \(Red Hat Enterprise Linux или RHEL\).

## Условные обозначения используемые в книге

В этой книге используются следующие типографские условные обозначения:

_Курсив_

Обозначает новые термины, URL-адреса, адреса электронной почты, имена файлов, расширения файлов, пути, каталоги и имена пакетов, а также утилиты Unix, команды, модули, параметры и аргументы.

`Моноширинный`

Используется для отображения примеров кода, содержимого файлов, взаимодействий командной строки, команд базы данных, имен библиотек и параметров.

**`Моноширинный полужирный`**

Обозначает команды или другой текст, который должен быть набран буквально пользователем. Также используется для акцентирования в коде.

_`Моноширинный курсив`_

Показывает текст, который должен быть заменен пользовательскими значениями.

_`[ Keywords and other stuff ]`_

Указывает необязательные ключевые слова и аргументы.

_`{ вариант-1 | вариант-2 }`_

Означает _`вариант-1`_ или _`вариант-2`_.

<table border="1" width="100%" cellpadding="5">
  <tr>
    <td>
    <p><img src="pics/tip.png" height="100" align="left">Этот элемент означает подсказку или предложение.</p>
    </td>
  </tr>
</table>

<table border="1" width="100%" cellpadding="5">
  <tr>
    <td>
    <p><img src="pics/note.png" height="100" align="left">Этот элемент обозначает общую заметку.</p>
    </td>
  </tr>
</table>

<table border="1" width="100%" cellpadding="5">
  <tr>
    <td>
    <p><img src="pics/warning.png" height="100" align="left">Этот элемент указывает на предупреждение или предостережение.</p>
    </td>
  </tr>
</table>

## Онлайн обучение O’Reilly

<table border="1" width="100%" cellpadding="5">
  <tr>
    <td>
    <p><img src="pics/oreilly.png" height="100" align="left">На протяжении почти 40 лет [O'Reilly Media](http://oreilly.com/) предоставляет технологии и бизнес-тренинги, знания и понимание, чтобы помочь компаниям добиться успеха.</p>
    </td>
  </tr>
</table>

Наша уникальная сеть экспертов и новаторов делится своими знаниями и опытом с помощью книг, статей, конференций и нашей онлайн-обучающей платформы. Платформа онлайн-обучения o'Reilly предоставляет вам по запросу доступ к живым учебным курсам, углубленным учебным путям, интерактивным средам кодирования и обширной коллекции текста и видео от O'Reilly и более чем 200 других издателей. Для получения дополнительной информации, пожалуйста, посетите [_http://oreilly.com_](http://www.oreilly.com/).

## Как с нами связаться

Пожалуйста, направляйте комментарии и вопросы, касающиеся этой книги, издателю:

* O'Reilly Media, Inc.
* 1005 Gravenstein Highway North
* Sebastopol, CA 95472
* 800-998-9938 (в США или Канаде)
* 707-829-0515 (международный или местный)
* 707-829-0104 (факс)

У нас есть веб-страница для этой книги, где мы перечисляем ошибки, примеры и любую дополнительную информацию. Вы можете получить доступ к этой странице по адресу [_https://oreil.ly/asterisk_tdg_5E_](https://oreil.ly/asterisk_tdg_5E).

Чтобы прокомментировать или задать технические вопросы об этой книге, отправьте электронное письмо по адресу [_bookquestions@oreilly.com_](mailto:bookquestions@oreilly.com).

Для получения дополнительной информации о наших книгах, курсах, конференциях и новостях смотрите наш веб-сайт по адресу [_http://www. oreilly.com_](http://www.oreilly.com/).

Facebook: [_http://facebook.com/oreilly_](http://facebook.com/oreilly)

Следуйте за нами в Twitter: [_http://twitter.com/oreillymedia_](http://twitter.com/oreillymedia)

Смотрите нас на YouTube: [_http://www.youtube.com/oreillymedia_](http://www.youtube.com/oreillymedia)

## Благодарности от Джима Ван Меггелена

Дэвиду Даффетту спасибо за главу об интернационализации, в которой он правильно рассматривает эту технологию с более глобальной точки зрения.

Спасибо Лейфу Мэдсену, Джареду Смиту и Расселу Брайанту за Ваш вклад в предыдущие издания этой книги. Это было весело летать в одиночку, но я не могу отрицать, что скучал по вам, ребята!

Особая благодарность Мэтту Фредриксону и Мэтту Джордану из Digium, которые щедро делились со мной своим временем и знаниями, и без которых я был бы потерян. Спасибо, ребята!

Спасибо моему редактору Джеффу Блейлу за то, что он держит меня в курсе событий и помогает принимать важные решения о содержании и темпе работы над книгой.

А также благодаря остальным невоспетым героям из производственного отдела О'Рейли. Это те люди, которые берут книгу и делают ее книгой О'Рейли.

Особенно я благодарен Джойс Уилмот и Дэну Дженкинсу, моей команде технического рецензирования за то, что они нашли время для работы над книгой и предоставили необходимую обратную связь.

Томас Камерон из RedHat щедро поделился со мной своими знаниями о Selinux и помог демистифицировать компонент Linux, который слишком часто остается отключенным.

Все участники сообщества Asterisk также должны поблагодарить покойного Джима Диксона за создание первых аппаратных интерфейсов телефонии с открытым исходным кодом, начало революции и предоставление его творений сообществу в целом.

Наконец, и это самое главное, спасибо Марку Спенсеру, оригинальному автору Asterisk и основателю Digium, за Asterisk, за [Pidgin](http://www.pidgin.im/), а также за вклад его творений в сообщество с открытым исходным кодом. Asterisk - это ваше наследие!
