# Содержание

* [Аннотация](README.md)
* [Вступление](foreword.md)
* [Предисловие](preface.md)
* [Глава 1. Революция в телефонии](chapter-01.md)
  - [Asterisk и VoIP: преодоление разрыва между традиционной и сетевой телефонией](chapter-01.md#asterisk-и-voip-преодоление-разрыва-между-традиционной-и-сетевой-телефонией)
  - [Массовые изменения требуют гибкости технологий](chapter-01.md#массовые-изменения-требуют-гибкости-технологий)
* [Глава 2. Архитектура Asterisk](glava-02.md)
* [Глава 3. Установка Asterisk](glava-03.md)
* [Глава 4. Сертификаты для безопасности конечных точек](glava-04.md)
* [Глава 5. Конфигурация пользовательских устройств](chapter-05.md)
  - [Концепции именования телефонов](chapter-05.md#концепции-именования-телефонов)
  - [Телефоны, софтфоны и телефонные адаптеры](chapter-05.md#телефоны-софтфоны-и-телефонные-адаптеры)
* [Глава 6. Основы диалплана](chapter-06.md)
  - [Синтаксис диалплана](chapter-06.md#синтаксис-диалплана)
    - [Контексты](chapter-06.md#контексты)
    - [Extensions (Расширения)](chapter-06.md#extensions-расширения)
    - [Приоритеты](chapter-06.md#приоритеты)
    - [Приложения](chapter-06.md#приложения)
    - [Приложения Answer(), Playback() и Hangup()](chapter-06.md#приложения-answer-playback-и-hangup)
    - [Базовый прототип диалплана](chapter-06.md#базовый-прототип-диалплана)
  - [Простой диалплан](chapter-06.md#простой-диалплан)
    - [Hello World](chapter-06.md#hello-world)
  - [Создание интерактивного диалплана](chapter-06.md#создание-интерактивного-диалплана)
    - [Приложения Goto(), Background() и WaitExten()](chapter-06.md#приложения-goto-background-и-waitexten)
    - [Обработка неверных значений и тайм-аутов](chapter-06.md#обработка-неверных-значений-и-тайм-аутов)
    - [Использование приложения Dial](chapter-06.md#использование-приложения-dial)
    - [Использование переменных](chapter-06.md#использование-переменных)
    - [Совпадения по шаблонам](chapter-06.md#совпадения-по-шаблонам)
    - [Включения (Includes)](chapter-06.md#включения-includes)
* [Глава 7. Внешние подключения](glava-07.md)
* [Глава 8. Голосовая почта](glava-08.md)
* [Глава 9. Интернационализация](glava-09.md)
* [Глава 10. Погружение в диалплан](chapter-10.md)
  - [Выражения и манипуляции с переменными](chapter-10.md#выражения-и-манипуляции-с-переменными)
    - [Базовые выражения](chapter-10.md#базовые-выражения)
    - [Операторы](chapter-10.md#операторы)
  - [Функции диалплана](chapter-10.md#функции-диалплана)
    - [Синтаксис](chapter-10.md#синтаксис)
    - [Примеры функций диалплана](chapter-10.md#примеры-функций-диалплана)
  - [Условное ветвление](chapter-10.md#условное-ветвление)
    - [Приложение GotoIf](chapter-10.md#приложение-gotoif)
    - [Условное ветвление по времени с GotoIfTime](chapter-10.md#условное-ветвление-по-времени-с-gotoiftime)
  - [GoSub](chapter-10.md#gosub)
    - [Определение подпрограмм](chapter-10.md#определение-подпрограмм)
    - [Возврат из подпрограммы](chapter-10.md#возврат-из-подпрограммы)
  - [Локальные (Local) каналы](chapter-10.md#локальные-local-каналы)
  - [Использование базы данных Asterisk](chapter-10.md#использование-базы-данных-asterisk)
    - [Хранение данных в AstDB](chapter-10.md#хранение-данных-в-astdb)
    - [Получение данных из AstDB](chapter-10.md#получение-данных-из-astdb)
    - [Удаление данных из AstDB](chapter-10.md#удаление-данных-из-astdb)
    - [Использование AstDB в диалплане](chapter-10.md#использование-astdb-диалплане)
  - [Полезные функции Asterisk](chapter-10.md#полезные-функции-asterisk)
    - [Концеренц-связь с ConfBridge()](chapter-10.md#конференц-связь-с-confbridge)
  - [Полезные функции диалплана](chapter-10.md#полезные-функции-диалплана)
    - [CALLERID](chapter-10.md#callerid)
    - [CHANNEL](chapter-10.md#channel)
    - [CURL](chapter-10.md#curl)
    - [CUT](chapter-10.md#cut)
    - [IF и STRFTIME](chapter-10.md#if-и-strftime)
    - [LEN](chapter-10.md#len)
    - [REGEX](chapter-10.md#regex)
    - [STRFTIME](chapter-10.md#strftime)
* [Глава 11. Функции АТС, включая парковку, пейджинг и конференц-связь](glava-11.md)
* [Глава 12. Automatic Call Distribution Queues](glava-12.md)
* [Глава 13. Состояния устройств](glava-13.md)
* [Глава 14. Автосекретарь](glava-14.md)
* [Глава 15. Интеграция реляционной базы данных](glava-15.md)
* [Глава 16. Введение в интерактивное голосовое меню](glava-16.md)
* [Глава 17. AMI и файлы вызовов](glava-17.md)
* [Глава 18. AGI](glava-18.md)
* [Глава 19. Asterisk REST Interface](glava-19.md)
* [Глава 20. WebRTC](glava-20.md)
* [Глава 21. Системный мониторинг и журналирование](glava-21.md)
* [Глава 22. Безопасность](glava-22.md)
* [Глава 23. Asterisk: Будущее телефонии](glava-23.md)
* [Об авторах](about-the-authors.md)
* [Послесловие](colophon.md)
